#define	MAXROB 24


#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h> 
#include	<time.h>


void	scambia(int i,int j,char *in);
void	mischia(int i, char *in);
int	getval(char *from);
void 	analisi(char arg, int nr);
void	finale();
void	init(FILE *fp, char status);
void	stampa(FILE *fp, int maxrow, int nr);
void	save(int k);
void	esci();
void	scambiaf2f(int i,int j,char *in);
void 	analisif2f(char arg, int nr);
void	mischiaf2f(int j, char *in);
void	mainf2f(char *robstring);
void	savef2f(int k);
void	uso();

int	numrob=0,limrob;
int	numinc=0,mnuminc=0;
char	rob[MAXROB+1][50];
int	data[MAXROB+1][4];
long	c=0,bias=0;
int	matches=100;
char	*in;
char	fileout[25]="parziali.txt";
char	temp[80];
char	log=0;
FILE	*flog;
char	extcount[100];
char	ordine=0;
int	rep=1;
char	rtest=0,mtest=0;
char	quiet=0;
long	ltime;
char	versio[50]="TORNEO99 for Linux v4.8"; 


int	main(int argc, char *argv[])
{

	unsigned int 	k;
	long	L;
	char	i,j,z,rp,f2f=0;
	char	parameter[256],r[80];
	char    pars[256],nr[10];
	FILE	*fp;
	char	robstring[100]="rob.txt";
	char	nuovo=0;


	if (argc!=1) {

		if(!strcmp(argv[1],"save")) {
			printf("\n\n\n\n\nCROBOTS %s\nCopyright (C) Michelangelo Messina\n",versio); 
			printf("e-mail mmessina@altavista.net\n       m.messina@mclink.it\n\n\n\n"); 

			if (argc>2) {
				strcpy(temp,argv[2]);
				if(temp[strlen(temp)-1] !='/') strcat(temp,"/");
				strcat(temp,"cmnd");
			}
			else strcpy(temp,"cmnd");
			if((fp=fopen(temp,"wt"))==NULL) {
				printf("Errore\nFile %s non creato",temp);
				exit(-1);
			}
			fprintf(fp,"save\n");
			fclose(fp);
			printf("Inviato comando save\n");
			exit(0);
		}

		else if(!strcmp(argv[1],"quit")) {
			printf("\n\n\n\n\nCROBOTS %s\nCopyright (C) Michelangelo Messina\n",versio); 
			printf("e-mail mmessina@altavista.net\n       m.messina@mclink.it\n\n\n\n"); 
			if (argc>2) {
				strcpy(temp,argv[2]);
				if(temp[strlen(temp)-1] !='/') strcat(temp,"/");
				strcat(temp,"cmnd");
			}
			else strcpy(temp,"cmnd");
			if((fp=fopen(temp,"wt"))==NULL) {
				printf("Errore\nFile %s non creato",temp);
				exit(-1);
			}
			fprintf(fp,"quit\n");
			fclose(fp);
			printf("Inviato comando quit\n");
			exit(0);
		}
		else if(!strcmp(argv[1],"agg")) {
			printf("\n\n\n\n\nCROBOTS %s\nCopyright (C) Michelangelo Messina\n",versio); 
			printf("e-mail mmessina@altavista.net\n       m.messina@mclink.it\n\n\n\n"); 
			if (argc>2) {
				strcpy(temp,argv[2]);
				if(temp[strlen(temp)-1] !='/') strcat(temp,"/");
				strcat(temp,"cmnd");
			}
			else strcpy(temp,"cmnd");
			if((fp=fopen(temp,"wt"))==NULL) {
				printf("Errore\nFile %s non creato",temp);
				exit(-1);
			}
			fprintf(fp,"\n");
			fclose(fp);
			printf("Inviato comando aggiorna\n");
			exit(0);
		}

		else for(k=1;k<argc;k++)
		{
			if(argv[k][0]=='-') {
				if((tolower(argv[k][1]))=='f') f2f=1;
				else if((tolower(argv[k][1]))=='r') {
					rtest=1;
					strcpy(rob[0],(argv[k]+3));
					strcat(rob[0]," ");
				}
				else if((tolower(argv[k][1]))=='m') {
					mtest=1;
					mnuminc=getval(argv[k]);
				}
				else if((tolower(argv[k][1]))=='o') ordine=1;
				else if((tolower(argv[k][1]))=='x') rep=0;
				else if((tolower(argv[k][1]))=='t') log=1;
				else if((tolower(argv[k][1]))=='l') limrob=getval(argv[k]);
				else if((tolower(argv[k][1]))=='q') quiet=1;

			}
			else strcpy(robstring,argv[k]);
		}


	}
	if((in=(char *)calloc((MAXROB*(MAXROB-1)*(MAXROB-2)*(MAXROB-3)/6)+1,sizeof(char)))==NULL) {
		printf("Memoria non allocata\n");
		exit(-1);
	}


	remove("cmnd");
	if(!quiet) {
		printf("\n\n\n\n\nCROBOTS %s\nCopyright (C) Michelangelo Messina\n",versio);
		printf("e-mail mmessina@altavista.net\n       m.messina@mclink.it\n\n\n\n");
		printf("Un ringraziamento speciale a\n TOM POINTEXTER - autore del programma CROBOTS\n\n");
		printf("\n\n\n\nDedicato a tutti gli amanti di Crobots");
		if(f2f) printf("\n\nModalita' Face2Face");
		else printf("\n\n");
		printf("\n\n Premi invio\n");
		getchar();
	}
	extcount[0]=0;

	if(f2f) mainf2f(robstring);

	if((fp=fopen("incontri.dat","rt"))!=NULL) {
		if(!quiet) {
			printf("Ho trovato un salvataggio precedente !\n");
			printf("Digitare N se si vuole iniziare un nuovo torneo (i vecchi dati saranno persi)\n");
			if((z=getchar())=='N' || z=='n') {
				nuovo=1;
				fclose (fp);
				remove("incontri.dat");
			}
		}
	}
	else nuovo=1;
	if (nuovo) {
		if((fp=fopen(robstring, "rb"))==NULL) uso();
		init(fp,0);
		fclose(fp);

		for(i=0;i<numrob;i++) for(j=0;j<3;j++) data[i][j]=0;

		for(i=0;i<limrob;i++) {
			for(j=i+1;j<numrob;j++)
				for(k=j+1;k<numrob;k++)
					for(z=k+1;z<numrob;z++)
					{
						in[(long)c*4]=i;
						in[(long)c*4+1]=j;
						in[(long)c*4+2]=k;
						in[((long)(c++))*4+3]=z;
					}
		}

		for(i=1,k=0;i<=limrob;i++)
			k+=(int)((long)(numrob-i)*(long)(numrob-(i+1))*(long)(numrob-(i+2))/6);
		ltime=time(NULL);
		srandom( (unsigned int)(ltime/2));
		if (!ordine) {
			for(c=0;c<k;c++) scambia(c, (int) (c+(k-c)*(float)random()/ ((float)RAND_MAX+1)), in);
		}
		remove("scores.txt");
	}
	else
	{
		init(fp,1);

		fscanf(fp, "%d", &k);
		for(L=0;L<(4*(long)k);L++) {
			fscanf(fp, "%d", &in[L]);
		}
		for(i=0;i<numrob;i++) for(j=0;j<3;j++) {
			fscanf(fp,"%s",r);
			data[i][j]=atoi(r);
		}
		if (fscanf(fp,"%s",temp)!=EOF) { 
			bias=atol(temp);
			while (fgets(temp,80,fp)){
				if (toupper(temp[0])=='M' && strstr(temp,"=")) {
					if(!(matches=getval(temp))) matches=100;
				}
				else if (toupper(temp[0])=='X') rep=0;
				else if (toupper(temp[0])=='D') strcpy(fileout,strstr(temp,"=")+1);
				else if (toupper(temp[0])=='T') log=2;
				else if (toupper(temp[0])=='C') {
					strcpy(extcount,strstr(temp,"=")+1);
						if(quiet && (!strstr(extcount,">/dev/null")) ) {
						extcount[strlen(extcount)-1]=0;
						strcat(extcount," >/dev/null");
					}
				}
			}
		}
		fclose(fp);

		if (log==2) {
			if((flog=fopen("torneo.log","rt"))==NULL) {

				printf("Il file torneo.log non e' stato trovato\n Digitare S per continuare senza il log degli incontri\n");
				if((z=getchar())!='S' && z!='s') exit(-1);
				log=0;

			}
			else fclose(flog);
		}
	}
	if(!rep) {
		rep=numinc;
		numinc=1;
	}
	if (log){
		if(log==2) flog=fopen("torneo.log","ab");
		else flog=fopen("torneo.log","wb");
		if (flog==NULL) {
			printf("Non riesco a creare il file di log.\n");
			log=0;
			esci();
		}
		if (log==1) {
			fprintf(flog,"Torneo gestito da %s di Michelangelo Messina\n",versio);
			fprintf(flog,"Numero incontri=%ld",((long)k)*numinc*rep);
		}
	}
	else if (extcount[0]) extcount[0]=0;

	strcpy(pars,"crobots </dev/null >L -l200000 ");
	if(quiet) strcat(pars,"2>/dev/null -m");
	else strcat(pars,"-m");
	strcpy(nr,"0000");
	nr[0]='0'+(numinc)/10;
	nr[1]='0'+(numinc)%10;
	nr[2]=' ';
	nr[3]=0;
	strcat(pars,nr);

	for(c=0;c<k;c++) {
		for(rp=0;rp<rep;rp++) {
			mischia(c,in);
			strcpy(parameter,pars);
			strcat(parameter,rob[in[(long)c*4]]);
			strcat(parameter,rob[in[(long)c*4+1]]);
			strcat(parameter,rob[in[(long)c*4+2]]);
			strcat(parameter,rob[in[(long)c*4+3]]);
			if(system(parameter)) {
				printf("\nCMDLINE=%s\n",parameter);
				printf("\nProgramma interrotto\n");
				esci();
			}
			if(rp<(rep-1)) analisi(0,k);
		}

		if((fp=fopen("cmnd","rt"))!=NULL) {
			analisi(1,k);
			fscanf(fp,"%s",temp);
			fclose(fp);
			remove("cmnd");
			if(!strcmp("save",temp)) {
				remove("L");
				save(k);
				esci();
			}
			else if(!strcmp("quit",temp)) break;

		}
		else analisi(!((c+1)%matches),k);
	}
	remove("L");
	remove("incontri.dat");
	if (log) fclose(flog);
	finale();
	exit(0);
}

void	init(FILE *fp, char status)
{
	char	i;

	if(status){
		mtest=0;
		rtest=0;
		rep=1;
		log=0;
	}
	fscanf(fp, "%d",&numrob);
	fscanf(fp, "%d",&numinc);
	if(mtest) numinc=mnuminc;
	numrob+=rtest;
	for(i=rtest;i<numrob;i++) {
		fscanf(fp,"%s",rob[i]);
		strcat(rob[i]," ");
	}
	if (status) return;
	while (fgets(temp,80,fp)){
		if (toupper(temp[0])=='L' && strstr(temp,"=") &&(!limrob)) limrob=getval(temp);
		else if (toupper(temp[0])=='M' && strstr(temp,"=")) {
			if(!(matches=getval(temp))) matches=100;
		}
		else if (toupper(temp[0])=='X') rep=0;
		else if (toupper(temp[0])=='D') strcpy(fileout,strstr(temp,"=")+1);
		else if (toupper(temp[0])=='T') log=1;
		else if (toupper(temp[0])=='O') ordine=1;
		else if (toupper(temp[0])=='C') {
			strcpy(extcount,strstr(temp,"=")+1);
			if(quiet && (!strstr(extcount,">/dev/null")) ) {
				extcount[strlen(extcount)-1]=0;
				strcat(extcount," >/dev/null");
			}
		}
	}
	if ((!limrob)||(limrob>numrob)) limrob=numrob;
}

void	scambia(int i,int j,char *in)
{
	char k,temp;
	for(k=0;k<4;k++) {
		temp=in[(long)j*4+(long)k];
		in[(long)j*4+(long)k]=in[(long)i*4+(long)k];
		in[(long)i*4+(long)k]=temp;
	}
}

void	mischia(int i, char *in)
{
	char v,temp,z;

	for(v=0;v<4;v++) {
		z=(int) (4.0*(float) random()/((float) RAND_MAX+1.0));
		temp=in[(long)i*4+(long)z];
		in[(long)i*4+(long)z]=in[(long)i*4+(long)v];
		in[(long)i*4+(long)v]=temp;
	}
}


void save(int k)
{
	long	L;
	char	i,j;
	FILE	*fp;

	if((fp=fopen("incontri.dat","rt"))!=NULL) {
	    rename("incontri.dat","incontri.bak");
	    fclose (fp);
	}
	if((fp=fopen("incontri.dat","wt"))!=NULL) {
		fprintf(fp, "%d\n",numrob);
		if(rep==1) fprintf(fp, "%d\n",numinc);
		else fprintf(fp,"%d\n",rep);
		for(i=0;i<numrob;i++)
			fprintf(fp,"%s\n",rob[i]);
		fprintf(fp,"%u\n",k-c-1);

		for(L=(4*((long)c+1));L<(4*(long)k);L++) {
			fprintf(fp, "%d\n", in[L]);
		}
		for(i=0;i<numrob;i++)
			for(j=0;j<3;j++) fprintf(fp,"%d\n",data[i][j]);
		fprintf(fp,"%d\n", bias+c+1);
		if (matches!=100) fprintf(fp, "M=%d\n", matches);
		if (rep!=1) fprintf(fp, "X\n");
		if (log) fprintf(fp, "T\n");
		if (extcount[0]) fprintf(fp, "C=%s\n",extcount);
		else fprintf(fp,"D=%s",fileout); /* ultimo !!! */

		fclose(fp);
	}
	else {
	    printf("Errore nel salvataggio!\n");
	    esci();
	}
}

void analisi(char arg, int nr)
{
	char	buffer[17][80];
	int	i,j,k;
	FILE	*fp;
	char	car,ncar;


	if((fp=fopen("L", "rt"))==NULL) {
		printf("Errore nel caricamento di L\n");
		esci();
	}
	i=0;
	while (!feof(fp)) {
		fscanf(fp,"%s",buffer[((++i)%17)]);
	}
	fclose (fp);

	if(log) {
		if((fp=fopen("L", "rb"))==NULL) {
			printf("Errore nel caricamento di L\n");
			esci();
		}
		car=fgetc(fp);
		while (!feof(fp)) {
			ncar=fgetc(fp);
			if(fputc(car,flog)==EOF) {
				printf("Errore nella scrittura del log\n");
				fclose(fp);
				esci();
			}
			car=ncar;
		}
		fflush(flog);
		fclose(fp);
	}

	i++;

	for(j=0;j<4;j++)
	{
		k=in[c*4+j];
		data[k][0]+=numinc;
		data[k][1]+=getval((char *)buffer[((i+4*j+2)%17)]);
		data[k][2]+=getval((char *)buffer[((i+4*j+3)%17)]);

	}

	if(arg) {
		if (!log) save(nr);
		if(extcount[0]) system(extcount);
		else {
			if((fp=fopen(fileout, "wt"))==NULL) {
				printf("Errore nella scrittura dei risultati\n");
				esci();
			}
			stampa(fp,100,nr);
			fclose(fp);
		}
	}
}

int	getval(char *from)
{
	char *r;
	r=strchr(from,'=');
	return(atoi(r+1));
}

void finale()
{
	FILE	*fp;


	if(extcount[0]) system(extcount);
	if(!quiet) stampa(stdout,24,0);
	if((fp=fopen("scores.txt","wt"))==NULL) {
		printf("Risultati non salvati!\n");
		esci();
	}
	stampa(fp,100,0);
	fclose(fp);
	if (!quiet) printf("\n\n I risultati sono stati salvati nel file scores.txt\n");
	remove(fileout);
}

void stampa(FILE *fp,int maxrow, int nr)
{
	int	i,j,temp,classifica[25];
	float	media[25];

	for(i=0;i<numrob;i++) {
		if(data[i][0])
		media[i]=(float)(100*((float)data[i][1]+(float)data[i][2]/3)/data[i][0]);
		else media[i]=-1;
	}
	for(i=0;i<numrob;i++) classifica[i]=i;
	if (!nr) fprintf(fp, " Risultati finali:\n");
	else fprintf(fp," Risultati dopo %d incontri su %d (%d %%):\n",c+1+bias,nr+bias,(((long)(c+bias+1)*100))/(nr+bias));
	fprintf(fp,"Pos                     Robot   - partite - vinte - patte -  eff.%");
	for(i=0;i<numrob;i++) {
		for(j=i;j<numrob;j++) {
			if(media[classifica[i]]<media[classifica[j]]) {
				temp=classifica[i];
				classifica[i]=classifica[j];
				classifica[j]=temp;
			}
		}
	}
	for(i=0;i<numrob&&i<maxrow;i++) {
		if(data[classifica[i]][0])
		fprintf(fp,"\n%2d%32s %4d   %6d   %5d    %6.2f",(i+1),rob[classifica[i]],
		data[classifica[i]][0],	data[classifica[i]][1],
		data[classifica[i]][2],media[classifica[i]]);
		else fprintf(fp,"\n%2d%32s",(i+1),rob[classifica[i]]);
	}
}

void esci()
{
	if (log) fclose(flog);
	exit(-1);
}

void mainf2f(char *robstring)
{
	unsigned int 	k;
	long	L;
	char	i,j,z;
	int	rp;
	char	parameter[256],r[80];
	char    pars[256],nr[10];
	FILE	*fp;
	char	nuovo=0;



	if((fp=fopen("f2f.dat","rt"))!=NULL) {
		if(!quiet) {
			printf("Ho trovato un salvataggio precedente !\n");
			printf("Premere N se si vuole iniziare un nuovo torneo (i vecchi dati saranno persi)\n");
			if((z=getchar())=='N' || z=='n') {
				nuovo=1;
				fclose (fp);
				remove("f2f.dat");
			}
		}
	}
	else nuovo=1;
	if (nuovo) {
		if((fp=fopen(robstring, "rb"))==NULL) uso();
		init(fp,0);
		fclose(fp);
		for(i=0;i<numrob;i++) for(j=0;j<3;j++) data[i][j]=0;
		for(i=0;i<limrob;i++) {
			for(j=i+1;j<numrob;j++)
			{
				in[(long)c*2]=i;
				in[(long)(c++)*2+1]=j;
			 }
		}

		k=c;
		ltime=time(NULL);
		srandom( (unsigned int)(ltime/2));
		if (!ordine) {
			for(c=0;c<k;c++) scambiaf2f(c, (int) (c+(k-c)*(float)random()/ ((float)RAND_MAX+1)), in);
		}
		remove("scores.txt");
	}
	else
	{
		init(fp,1);
		fscanf(fp, "%d", &k);
		for(L=0;L<(2*(long)k);L++) {
			fscanf(fp, "%d", &in[L]);
		}
		for(i=0;i<numrob;i++) for(j=0;j<3;j++) {
			fscanf(fp,"%s",r);
			data[i][j]=atoi(r);
		}
		if (fscanf(fp,"%s",temp)!=EOF) { 
			bias=atol(temp);
			while (fgets(temp,80,fp)){
				if (toupper(temp[0])=='M' && strstr(temp,"=")) {
					if(!(matches=getval(temp))) matches=100;
				}
				else if (toupper(temp[0])=='X') rep=0;
				else if (toupper(temp[0])=='D') strcpy(fileout,strstr(temp,"=")+1);
				else if (toupper(temp[0])=='T') log=2;
				else if (toupper(temp[0])=='C') {
					strcpy(extcount,strstr(temp,"=")+1);
					if(quiet && (!strstr(extcount,">/dev/null")) ) {
						extcount[strlen(extcount)-1]=0;
						strcat(extcount," >/dev/null");
					}
				}
			}
		}
		fclose(fp);
		if (log==2) {
			if((flog=fopen("f2f.log","rt"))==NULL) {

				printf("Il file f2f.log non e' stato trovato\nPremere S per continuare senza il log degli incontri\n");
				if((z=getchar())!='S' && z!='s') exit(-1);
				log=0;

			}
			else fclose(flog);
		}
	}
	if(!rep) {
		rep=numinc;
		numinc=1;
	}
	if (log){
		if(log==2) flog=fopen("f2f.log","ab");
		else flog=fopen("f2f.log","wb");
		if (flog==NULL) {
			printf("Non riesco a creare il file di log.\n");
			log=0;
			esci();
		}
		if (log==1) {
			fprintf(flog,"Torneo gestito da %s di Michelangelo Messina\n",versio);
			fprintf(flog,"Numero incontri=%ld\n",((long)k)*numinc*rep);
		}
	}
	else if (extcount[0]) extcount[0]=0;

	strcpy(pars,"crobots </dev/null >L -l200000 ");
	if(quiet) strcat(pars,"2>/dev/null -m");
	else strcat(pars,"-m"); 
	strcpy(nr,"0000");
	nr[0]='0'+(numinc)/1000;
	nr[1]='0'+(numinc-1000*(int)((numinc)/1000))/100;
	nr[2]='0'+(numinc-100*(int)((numinc)/100))/10;
	nr[3]='0'+numinc%10;
	nr[4]=' ';
	nr[5]=0;
	strcat(pars,nr);
	for(c=0;c<k;c++) {
		for(rp=0;rp<rep;rp++) {
			mischiaf2f(c,in);
			strcpy(parameter,pars);
			strcat(parameter,rob[in[(long)c*2]]);
			strcat(parameter,rob[in[(long)c*2+1]]);
			if(system(parameter)) {
				printf("\nCMDLINE=%s\n",parameter);
				printf("\nProgramma interrotto\n");
				esci();
			}
			if (rp<(rep-1)) analisif2f(0,k);
		}
		if((fp=fopen("cmnd","rt"))!=NULL) {
			analisif2f(1,k);
			fscanf(fp,"%s",temp);
			fclose(fp);
			remove("cmnd");
			if(!strcmp("save",temp)) {
				remove("L");
				savef2f(k);
				esci();
			}
			else if(!strcmp("quit",temp)) break;

		}
		else analisif2f(!((c+1)%matches),k);

	}
	remove("L");
	remove("f2f.dat");
	if (log) fclose(flog);
	finale();
	exit(0);
}


void	scambiaf2f(int i,int j,char *in)
{
	char k,temp;
	for(k=0;k<2;k++) {
		temp=in[(long)j*2+(long)k];
		in[(long)j*2+(long)k]=in[(long)i*2+(long)k];
		in[(long)i*2+(long)k]=temp;
	}

}

void mischiaf2f(int i, char *in)
{
	char v,temp,z;

	ltime=time(NULL);
	srandom( (unsigned int)(ltime));
	for(v=0;v<2;v++) {
		z=(int) (2.0*(float) random()/((float) RAND_MAX+1.0));
		temp=in[(long)i*2+(long)z];
		in[(long)i*2+(long)z]=in[(long)i*2+(long)v];
		in[(long)i*2+(long)v]=temp;
	}
}



void analisif2f(char arg, int nr)
{
	char	buffer[10][80];
	int	i,j,k;
	FILE	*fp;
	char	car,ncar;


	if((fp=fopen("L", "rt"))==NULL) {
		printf("Errore nel caricamento di L\n");
		esci();
	}
	i=0;
	while (!feof(fp)) {
		fscanf(fp,"%s",buffer[((++i)%10)]);
	}
	fclose (fp);

	if(log) {
		if((fp=fopen("L", "rb"))==NULL) {
			printf("Errore nel caricamento di L\n");
			esci();
		}
		car=fgetc(fp);
		while (!feof(fp)) {
			ncar=fgetc(fp);
			if(fputc(car,flog)==EOF) {
				printf("Errore nella scrittura del log\n");
				fclose(fp);
				esci();
			}
			car=ncar;
		}
		fflush(flog);
		fclose(fp);
	}

	i++;

	for(j=0;j<2;j++)
	{
		k=in[c*2+j];
		data[k][0]+=numinc;
		data[k][1]+=getval((char *)buffer[((i+4*j+3)%10)]);
		data[k][2]+=getval((char *)buffer[((i+4*j+4)%10)]);

	}

	if(arg) {
		if(!log) savef2f(nr); 
		if(extcount[0]) system(extcount);
		else {
			if((fp=fopen(fileout, "wt"))==NULL) {
				printf("Errore nella scrittura dei risultati\n");
				esci();
			}
			stampa(fp,100,nr);
			fclose(fp);
		}

	}
}

void uso()
{
	printf("Uso: t99l [switches] [file di comando]\n\n");
	printf("Per default il file di comando e' ROB.TXT\n\n");
	printf("Switches:\n\n");
	printf("-f   : attiva modalita' Face2Face\n");
	printf("-m=x : x incontri per match \n");
	printf("-o   : torneo ordinato\n");
	printf("-x   : avvia piu' volte crobots\n");
	printf("-t   : crea il file di log  \n");
	printf("-l=x : torneo completato dai primi x robots\n");
	printf("-q   : modalita' 'QUIET' per i batch\n");
	printf("\n\nQuesti switches hanno la priorita' su quelli inseriti nel file di comando\n\n");
	printf("\n\n Premi invio\n"); 
	getchar(); 

	printf("Il file di comando deve contenere:\nnumero robot\nnumero incontri\nrobot del torneo (max %d, comprensivi di path)\n\n",MAXROB);
	printf("Opzioni da inserire dopo l'ultimo robot, obbligatoriamente senza spazi:\n\nL=n (con n <=numero robot)\n     ");
	printf("per far giocare solo gli incontri dei primi n robots\n");
	printf("O    per avere il torneo in ordine\n");
	printf("M=n  per avere l'aggiornamento della situazione ogni n partite (default 100)\n");
	printf("X    per avviare piu' volte crobots.exe col parametro -m1\n");
	printf("D=fileoutput\n     per avere l'aggiornamento su un file diverso da parziali.txt\n");
	printf("T    per conservare il log completo degli incontri nel file torneo.log\n");
	printf("C=fileconteggio (da usare in congiunzione all'opzione T - creazione log)\n     per usare un programma esterno per l'analisi\n");
	exit(-1);

}
void	savef2f(int k)
{
	long	L;
	char	i,j;
	FILE	*fp;

	if((fp=fopen("f2f.dat","rt"))!=NULL) {
	    rename("f2f.dat","f2f.bak");
	    fclose (fp);
	}
	if((fp=fopen("f2f.dat","wt"))!=NULL) {
		fprintf(fp, "%d\n",numrob);
		if(rep==1) fprintf(fp, "%d\n",numinc);
		else fprintf(fp,"%d\n",rep);
		for(i=0;i<numrob;i++) fprintf(fp,"%s\n",rob[i]);
		fprintf(fp,"%u\n",k-c-1);
		for(L=(2*((long)c+1));L<(2*(long)k);L++) {
			fprintf(fp, "%d\n", in[L]);
		}
		for(i=0;i<numrob;i++)
			for(j=0;j<3;j++) fprintf(fp,"%d\n",data[i][j]);
		fprintf(fp,"%d\n", bias+c+1);
		if (matches!=100) fprintf(fp, "M=%d\n", matches);
		if (rep!=1) fprintf(fp, "X\n");
		if (log) fprintf(fp, "T\n");
		if (extcount[0]) fprintf(fp, "C=%s\n",extcount);
		else fprintf(fp,"D=%s",fileout);  /* ultimo !!! */

		fclose(fp);
	}
	else {
		printf("Errore nel salvataggio!\n");
		esci();
	}
}

